module examples.

accum_sig atom.

accumulate listmanip.

/* ********************************************************************
 * General Definitions for Modeling the Domain
 ******************************************************************** */

local	vars		list tm -> o.
local   oo2daggerJudg   form -> judg -> o.
local   dont_care       tm -> form -> o.
local   dont_cares      list tm -> form -> o.
local   unchanged1      tm -> int -> form -> o.
local   unchanged       list tm -> int -> form -> o.
local   well_defined1   tm -> list judg -> o.
local   well_defined    list tm -> list judg -> o.

vars (p53::mdm2::dNAdam::nil).

oo2daggerJudg A J :- J = (dagger A @ 0).

dont_care T A :- A = (pres T +o absent T).

dont_cares (T::nil) A :- !,
  dont_care T A.
dont_cares (T::Ts) A :- !,
  dont_care T A1, dont_cares Ts A2, A = (A1 *o A2).
dont_cares nil A :- !, A = hOne.

unchanged1 T W A :- A = (!! ((pres T at W ->> pres T at (W + 1)) &a
                             (absent T at W ->> absent T at (W + 1)))).

unchanged (T::nil) W A :- !,
  unchanged1 T W A.
unchanged (T::Ts) W A :- !,
  unchanged1 T W A1, unchanged Ts W A2, A = (A1 *o A2).
unchanged nil W A :- !, A = hOne.

well_defined1 T (J1::J2::nil) :-
  oo2daggerJudg (pres T *o absent T ->> hZero) J1,
  oo2daggerJudg (pres T +o absent T) J2.

well_defined (T::nil) Js :- !,
  well_defined1 T Js.
well_defined (T::Ts) Js :- !,
  well_defined1 T Js1, well_defined Ts Js2, append Js1 Js2 Js.
well_defined nil (J::nil) :-
  oo2daggerJudg hOne J.
  
/* ********************************************************************
 * General Rules
 ******************************************************************** */

type		rule1		form -> o.
type		rule2		form -> o.
type		rule3		form -> o.
type		rule4		form -> o.
type		rule5		form -> o.
type		rule6		form -> o.

local   active          list tm -> tm -> tm -> form -> o.
local   active_c        list tm -> tm -> tm -> form -> o.
local   active_s        list tm -> tm -> tm -> form -> o.
local   inhib           list tm -> tm -> tm -> form -> o.
local   inhib_c         list tm -> tm -> tm -> form -> o.
local   inhib_s         list tm -> tm -> tm -> form -> o.
local   fireable_pres   list tm -> tm -> tm -> form -> o.
local   fireable_abs    list tm -> tm -> tm -> form -> o.
local   not_fireable_pres   list tm -> tm -> tm -> form -> o.
local   not_fireable_abs    list tm -> tm -> tm -> form -> o.
local   fireable1       form -> o.
local   fireable2       form -> o.
local   fireable3       form -> o.
local   fireable4       form -> o.
local   fireable5       form -> o.
local   fireable6       form -> o.
local   not_fireable1   form -> o.
local   not_fireable2   form -> o.
local   not_fireable3   form -> o.
local   not_fireable4   form -> o.
local   not_fireable5   form -> o.
local   not_fireable6   form -> o.

active Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta +o (pres Ta *o pres Tb) +o (pres Ta *o absent Tb)) ->>
       (step (pres Ta *o pres Tb) *o (down u\ (B u)))).

active_c Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta +o (pres Ta *o pres Tb) +o (pres Ta *o absent Tb)) ->>
       (step (absent Ta *o pres Tb) *o (down u\ (B u)))).

active_s Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((absent Ta +o (absent Ta *o pres Tb) +o (absent Ta *o absent Tb)) ->>
       (step (absent Ta *o absent Tb) *o (down u\ (B u)))).

inhib Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta +o (pres Ta *o pres Tb) +o (pres Ta *o absent Tb)) ->>
       (step (pres Ta *o absent Tb) *o (down u\ (B u)))).

inhib_c Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta +o (pres Ta *o pres Tb) +o (pres Ta *o absent Tb)) ->>
       (step (absent Ta *o absent Tb) *o (down u\ (B u)))).

inhib_s Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((absent Ta +o (absent Ta *o pres Tb) +o (absent Ta *o absent Tb)) ->>
       (step (absent Ta *o pres Tb) *o (down u\ (B u)))).

fireable_pres Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 B,
  A = ((pres Ta +o (pres Ta *o pres Tb) +o (pres Ta *o absent Tb)) *o B).

fireable_abs Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 B,
  A = ((absent Ta +o (absent Ta *o pres Tb) +o (absent Ta *o absent Tb)) *o B).

not_fireable_pres Vs Ta Tb A :-
  dont_care Tb B,
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 C,
  A = (absent Ta *o (B *o C)).

not_fireable_abs Vs Ta Tb A :-
  dont_care Tb B,
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 C,
  A = (pres Ta *o (B *o C)).

rule1 J :- vars Vs, inhib Vs dNAdam mdm2 J.
rule2 J :- vars Vs, inhib_s Vs mdm2 p53 J.
rule3 J :- vars Vs, active Vs p53 mdm2 J.
rule4 J :- vars Vs, inhib Vs mdm2 p53 J.
rule5 J :- vars Vs, inhib_c Vs p53 dNAdam J.
rule6 J :- vars Vs, inhib_s Vs dNAdam mdm2 J.

fireable1 A :- vars Vs, fireable_pres Vs dNAdam mdm2 A.
fireable2 A :- vars Vs, fireable_abs Vs mdm2 p53 A.
fireable3 A :- vars Vs, fireable_pres Vs p53 mdm2 A.
fireable4 A :- vars Vs, fireable_pres Vs mdm2 p53 A.
fireable5 A :- vars Vs, fireable_pres Vs p53 dNAdam A.
fireable6 A :- vars Vs, fireable_abs Vs dNAdam mdm2 A.

not_fireable1 A :- vars Vs, not_fireable_pres Vs dNAdam mdm2 A.
not_fireable2 A :- vars Vs, not_fireable_abs Vs mdm2 p53 A.
not_fireable3 A :- vars Vs, not_fireable_pres Vs p53 mdm2 A.
not_fireable4 A :- vars Vs, not_fireable_pres Vs mdm2 p53 A.
not_fireable5 A :- vars Vs, not_fireable_pres Vs p53 dNAdam A.
not_fireable6 A :- vars Vs, not_fireable_abs Vs dNAdam mdm2 A.

/* ********************************************************************
 * Strong Rules
 ******************************************************************** */

type		s_rule1		form -> o.
type		s_rule2		form -> o.
type		s_rule3		form -> o.
type		s_rule4		form -> o.
type		s_rule5		form -> o.
type		s_rule6		form -> o.

local   s_active          list tm -> tm -> tm -> form -> o.
local   s_active_c        list tm -> tm -> tm -> form -> o.
local   s_active_s        list tm -> tm -> tm -> form -> o.
local   s_inhib           list tm -> tm -> tm -> form -> o.
local   s_inhib_c         list tm -> tm -> tm -> form -> o.
local   s_inhib_s         list tm -> tm -> tm -> form -> o.
local   s_fireable_prespres       list tm -> tm -> tm -> form -> o.
local   s_fireable_presabs        list tm -> tm -> tm -> form -> o.
local   s_fireable_absentabs         list tm -> tm -> tm -> form -> o.
local   s_not_fireable_prespres   list tm -> tm -> tm -> form -> o.
local   s_not_fireable_presabs    list tm -> tm -> tm -> form -> o.
local   s_not_fireable_absentabs     list tm -> tm -> tm -> form -> o.
local   s_fireable1       form -> o.
local   s_fireable2       form -> o.
local   s_fireable3       form -> o.
local   s_fireable4       form -> o.
local   s_fireable5       form -> o.
local   s_fireable6       form -> o.
local   s_not_fireable1   form -> o.
local   s_not_fireable2   form -> o.
local   s_not_fireable3   form -> o.
local   s_not_fireable4   form -> o.
local   s_not_fireable5   form -> o.
local   s_not_fireable6   form -> o.

s_active Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta *o absent Tb) ->>
       (step (pres Ta *o pres Tb) *o (down u\ (B u)))).

s_active_c Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta *o absent Tb) ->>
       (step (absent Ta *o pres Tb) *o (down u\ (B u)))).

s_active_s Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((absent Ta *o pres Tb) ->>
       (step (absent Ta *o absent Tb) *o (down u\ (B u)))).

s_inhib Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta *o pres Tb) ->>
       (step (pres Ta *o absent Tb) *o (down u\ (B u)))).

s_inhib_c Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((pres Ta *o pres Tb) ->>
       (step (absent Ta *o absent Tb) *o (down u\ (B u)))).

s_inhib_s Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  pi u\ unchanged Vs1 u (B u),
  A = ((absent Ta *o absent Tb) ->>
       (step (absent Ta *o pres Tb) *o (down u\ (B u)))).

s_fireable_prespres Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 B,
  A = ((pres Ta *o pres Tb) *o B).

s_fireable_presabs Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 B,
  A = ((pres Ta *o absent Tb) *o B).

s_fireable_absentabs Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 B,
  A = ((absent Ta *o absent Tb) *o B).

s_not_fireable_prespres Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 C,
  A = (((absent Ta *o pres Tb) +o (pres Ta *o absent Tb) +o
        (absent Ta *o absent Tb)) *o C).

s_not_fireable_presabs Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 C,
  A = (((absent Ta *o absent Tb) +o (pres Ta *o pres Tb) +o
        (absent Ta *o pres Tb)) *o C).

s_not_fireable_absentabs Vs Ta Tb A :-
  list_diff Vs (Ta::Tb::nil) Vs1,
  dont_cares Vs1 C,
  A = (((pres Ta *o absent Tb) +o (absent Ta *o pres Tb) +o
        (pres Ta *o pres Tb)) *o C).

s_rule1 J :- vars Vs, s_inhib Vs dNAdam mdm2 J.
s_rule2 J :- vars Vs, s_inhib_s Vs mdm2 p53 J.
s_rule3 J :- vars Vs, s_active Vs p53 mdm2 J.
s_rule4 J :- vars Vs, s_inhib Vs mdm2 p53 J.
s_rule5 J :- vars Vs, s_inhib_c Vs p53 dNAdam J.
s_rule6 J :- vars Vs, s_inhib_s Vs dNAdam mdm2 J.

s_fireable1 A :- vars Vs, s_fireable_prespres Vs dNAdam mdm2 A.
s_fireable2 A :- vars Vs, s_fireable_absentabs Vs mdm2 p53 A.
s_fireable3 A :- vars Vs, s_fireable_presabs Vs p53 mdm2 A.
s_fireable4 A :- vars Vs, s_fireable_prespres Vs mdm2 p53 A.
s_fireable5 A :- vars Vs, s_fireable_prespres Vs p53 dNAdam A.
s_fireable6 A :- vars Vs, s_fireable_absentabs Vs dNAdam mdm2 A.

s_not_fireable1 A :- vars Vs, s_not_fireable_prespres Vs dNAdam mdm2 A.
s_not_fireable2 A :- vars Vs, s_not_fireable_absentabs Vs mdm2 p53 A.
s_not_fireable3 A :- vars Vs, s_not_fireable_presabs Vs p53 mdm2 A.
s_not_fireable4 A :- vars Vs, s_not_fireable_prespres Vs mdm2 p53 A.
s_not_fireable5 A :- vars Vs, s_not_fireable_prespres Vs p53 dNAdam A.
s_not_fireable6 A :- vars Vs, s_not_fireable_absentabs Vs dNAdam mdm2 A.

/* ********************************************************************
 * Properties
 ******************************************************************** */

kind		fname	type.
kind		jname	type.
kind		sname	type.

type		test_hyll	sname.
type		property1	sname.
type		property1a	sname.
type		property1b	sname.
type		property2	sname.
type		property3_0	sname.
type		property3_1	sname.
type		property3_2	sname.
type		property3_3	sname.
type		property3_4	sname.
type		property3_5	sname.
type		property3_6	sname.
type		property4_1	sname.
type		property4_2	sname.
type		property4_3	sname.
type		property4_4	sname.
type		property4_5	sname.
type		property4_6	sname.

type		formula		fname -> form -> o.
type		judgment	jname -> judg -> o.
type		sequent		sname -> seq -> o.
type		asequent	sname -> (int -> seq) -> o.

type		state0		fname.
type		state1		fname.
type		p4L		fname.
type		p4R		fname.

formula state0 (absent p53 *o pres mdm2).
formula state1 (pres p53 *o absent mdm2).

formula p4L ((pres p53 *o pres mdm2) +o (absent p53 *o absent mdm2)).
formula p4R (((pres p53 *o absent mdm2) +o (absent p53 *o pres mdm2)) *o A) :-
  dont_care dNAdam A.

asequent property1 (w\ (seq ((sig_w w)::nil) G ((A1 @ w)::nil) (A2 @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  formula state1 State1,
  dont_care dNAdam A0,
  A1 = pres dNAdam *o State0,
  A2 = delta 2 ((State1 *o A0) &a delta 2 (State0 *o A0)).

asequent property1a (w\ (seq ((sig_w w)::nil) G
           ((A1 @ w)::nil) (A2 @ (w + 2)))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  formula state1 State1,
  dont_care dNAdam A0,
  A1 = pres dNAdam *o State0,
  A2 = State1 *o A0.

asequent property1b (w\ (seq ((sig_w w)::nil) G
           ((State1 @ (w + 2))::nil) (State0 @ (w + 2 + 2)))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  formula state1 State1.

asequent property2 (w\ (seq ((sig_w w)::nil) G ((A1 @ w)::nil)
  (A2 @ (w + 1 + 1 + 1 + 1)))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  A1 = State0 *o pres dNAdam,
  A2 = State0 *o absent dNAdam.

asequent property3_0 (w \ (seq ((sig_w w)::nil) G ((P @ 0)::nil) (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  C = (P at 0).

asequent property3_1 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable1 A, not_fireable1 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property3_2 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable2 A, not_fireable2 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property3_3 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable3 A, not_fireable3 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property3_4 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable4 A, not_fireable4 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property3_5 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable5 A, not_fireable5 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property3_6 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef rule1 (a\ (dagger a @ 0)))::
       (fdef rule2 (a\ (dagger a @ 0)))::
       (fdef rule3 (a\ (dagger a @ 0)))::
       (fdef rule4 (a\ (dagger a @ 0)))::
       (fdef rule5 (a\ (dagger a @ 0)))::
       (fdef rule6 (a\ (dagger a @ 0)))::Js),
  formula state0 State0,
  P = State0 *o absent dNAdam,
  fireable6 A, not_fireable6 B,
  C = (P ->> ((A &a step P) +o B)).

asequent property4_1 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable1 A, s_not_fireable1 B,
  C = (L ->> ((A &a step R) +o B)).

asequent property4_2 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable2 A, s_not_fireable2 B,
  C = (L ->> ((A &a step R) +o B)).

asequent property4_3 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable3 A, s_not_fireable3 B,
  C = (L ->> ((A &a step R) +o B)).

asequent property4_4 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable4 A, s_not_fireable4 B,
  C = (L ->> ((A &a step R) +o B)).

asequent property4_5 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable5 A, s_not_fireable5 B,
  C = (L ->> ((A &a step R) +o B)).

asequent property4_6 (w \ (seq ((sig_w w)::nil) G nil (C @ w))) :-
  vars Vs, well_defined Vs Js,
  G = ((fdef s_rule1 (a\ (dagger a @ 0)))::
       (fdef s_rule2 (a\ (dagger a @ 0)))::
       (fdef s_rule3 (a\ (dagger a @ 0)))::
       (fdef s_rule4 (a\ (dagger a @ 0)))::
       (fdef s_rule5 (a\ (dagger a @ 0)))::
       (fdef s_rule6 (a\ (dagger a @ 0)))::Js),
  formula p4L L,
  formula p4R R,
  s_fireable6 A, s_not_fireable6 B,
  C = (L ->> ((A &a step R) +o B)).

sequent test_hyll (seq nil nil ((pres p53 @ 0)::nil) (pres p53 @ 0)).
