sig hyll.

/* This module provides the signature for the HyLL logic. */

/* Constraint domain is integers with addition */

kind	  tm		type.
kind	  form		type.
kind	  judg		type.
kind	  seq		type.
kind	  sig_item	type.

type	  hT		form.
type	  hOne		form.
type	  hZero		form.
type	  &a		form -> form -> form.
type	  *o		form -> form -> form.
type	  +o		form -> form -> form.
type	  ->>		form -> form -> form.
type	  !!		form -> form.
type	  all		(tm -> form) -> form.
type	  some		(tm -> form) -> form.
type	  at		form -> int -> form.
type	  down		(int -> form) -> form.
type	  wall		(int -> form) -> form.
type	  wsome		(int -> form) -> form.

type	  box		form -> form.
type	  diamond	form -> form.
type	  delta		int -> form -> form.
type	  step		form -> form.
type	  dagger	form -> form.

type	  @		form -> int -> judg.
type	  fdef		(form -> o) -> (form -> judg) -> judg.

type	  sig_w		int -> sig_item.
type	  sig_tm	tm -> sig_item.

type	  seq		(list sig_item) -> (list judg) -> (list judg)
	  		 -> judg -> seq.

infixl	  &a	140.
infixl	  *o	140.
infixl	  +o	140.
infixr	  ->>	130.
infix	  at	150.
infix	  @	120.
